VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMainWnd 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "vbSpec"
   ClientHeight    =   3765
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   4215
   Icon            =   "frmMainWnd.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   251
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   281
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picStatus 
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   0
      ScaleHeight     =   25
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   501
      TabIndex        =   1
      Top             =   3420
      Width           =   7515
      Begin VB.Label lblStatus 
         Caption         =   "Copyright 1999-2002 Grok Developments Ltd."
         Height          =   255
         Left            =   60
         TabIndex        =   2
         Top             =   90
         Width           =   4695
      End
      Begin VB.Line Line1 
         BorderColor     =   &H80000010&
         Index           =   3
         X1              =   0
         X2              =   400
         Y1              =   0
         Y2              =   0
      End
      Begin VB.Line Line1 
         BorderColor     =   &H80000014&
         Index           =   2
         X1              =   0
         X2              =   400
         Y1              =   1
         Y2              =   1
      End
   End
   Begin MSComDlg.CommonDialog dlgCommon 
      Left            =   60
      Top             =   2880
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picDisplay 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   2880
      Left            =   180
      OLEDropMode     =   1  'Manual
      ScaleHeight     =   192
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   256
      TabIndex        =   0
      Top             =   240
      Width           =   3840
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000014&
      Index           =   1
      X1              =   0
      X2              =   11880
      Y1              =   1
      Y2              =   1
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      Index           =   0
      X1              =   -4
      X2              =   11880
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu mnuFileMain 
      Caption         =   "&File"
      Begin VB.Menu mnuFile 
         Caption         =   "&Open..."
         Index           =   1
      End
      Begin VB.Menu mnuFile 
         Caption         =   "&Save As..."
         Index           =   2
      End
      Begin VB.Menu mnuFile 
         Caption         =   "-"
         Index           =   3
      End
      Begin VB.Menu mnuFile 
         Caption         =   "Load &Binary..."
         Index           =   4
      End
      Begin VB.Menu mnuFile 
         Caption         =   "-"
         Index           =   5
      End
      Begin VB.Menu mnuFile 
         Caption         =   "&Reset Spectrum"
         Index           =   6
      End
      Begin VB.Menu mnuFile 
         Caption         =   "-"
         Index           =   7
      End
      Begin VB.Menu mnuFile 
         Caption         =   "E&xit"
         Index           =   8
      End
   End
   Begin VB.Menu mnuOptionsMain 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptions 
         Caption         =   "&General Settings..."
         Index           =   1
      End
      Begin VB.Menu mnuOptions 
         Caption         =   "&Display..."
         Index           =   2
      End
      Begin VB.Menu mnuOptions 
         Caption         =   "-"
         Index           =   3
      End
      Begin VB.Menu mnuOptions 
         Caption         =   "&Tape Controls..."
         Index           =   4
      End
   End
   Begin VB.Menu mnuHelpMain 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelp 
         Caption         =   "Spectrum &Keyboard..."
         Index           =   1
      End
      Begin VB.Menu mnuHelp 
         Caption         =   "-"
         Index           =   2
      End
      Begin VB.Menu mnuHelp 
         Caption         =   "&About vbSpec..."
         Index           =   3
      End
   End
End
Attribute VB_Name = "frmMainWnd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' /*******************************************************************************
'   frmMainWnd.frm within vbSpec.vbp
'
'   Main application window. Contains the Spectrum display output, processes
'   Keypresses, and contains a timer object used for maintaining the emulator
'   at 50 frames/sec on a fast enough machine, and a common dialog control for
'   use by file open/save operations.
'
'   Author: Chris Cowley <ccowley@grok.co.uk>
'
'   Copyright (C)1999-2001  Grok Developments Ltd.
'   http://www.grok.co.uk/
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' *******************************************************************************/

Option Explicit




Private Sub FileOpenDialog()
    On Error Resume Next
    
    err.Clear
    dlgCommon.DialogTitle = "Open Snapshot or ROM image"
    dlgCommon.DefaultExt = ".sna"
    dlgCommon.FileName = ""
    dlgCommon.Filter = "All Spectrum Files (*.sna;*.z80;*.tap;*.tzx;*.rom;*.scr)|*.sna;*.z80;*.tap;*.tzx;*.rom;*.scr|SNA snapshots (*.sna)|*.sna|Z80 snapshots (*.z80)|*.z80|ROM images (*.rom)|*.rom|Tape files (*.tap;*.tzx)|*.tap;*.tzx|Screen images (*.scr)|*.scr|All Files|*.*"
    dlgCommon.Flags = cdlOFNFileMustExist Or cdlOFNExplorer Or cdlOFNLongNames
    dlgCommon.CancelError = True
    dlgCommon.ShowOpen
    If err.Number = cdlCancel Then
        Exit Sub
    End If
    
    If dlgCommon.FileName <> "" Then
        Select Case LCase$(Right$(dlgCommon.FileName, 4))
        Case ".z80"
            LoadZ80Snap dlgCommon.FileName
        Case ".rom"
            Z80Reset
            If glEmulatedModel <> 0 And glEmulatedModel <> 5 Then
                SetEmulatedModel 0
            End If
            LoadROM dlgCommon.FileName
        Case ".sna"
            LoadSNASnap dlgCommon.FileName
        Case ".tap"
            OpenTAPFile dlgCommon.FileName
        Case ".tzx"
            OpenTZXFile dlgCommon.FileName
        Case ".scr"
            LoadScreenSCR dlgCommon.FileName
        Case Else
            ' try opening it as a SNA file
            LoadSNASnap dlgCommon.FileName
        End Select
    End If
End Sub




Private Sub FileSaveAsDialog()
    On Error Resume Next
    
    err.Clear
    dlgCommon.DialogTitle = "Save As"
    dlgCommon.DefaultExt = ".z80"
    dlgCommon.FileName = ""
    dlgCommon.Filter = "Z80 snapshot (*.z80)|*.z80|SNA snapshot (*.sna)|*.sna|ROM image (*.rom)|*.rom|Screen Bitmap (*.bmp)|*.bmp|Screen Image (*.scr)|*.scr"
    dlgCommon.Flags = cdlOFNPathMustExist Or cdlOFNOverwritePrompt Or cdlOFNExplorer Or cdlOFNLongNames Or cdlOFNHideReadOnly Or cdlOFNNoReadOnlyReturn
    dlgCommon.CancelError = True
    dlgCommon.ShowSave
    If err.Number = cdlCancel Then
        Exit Sub
    End If
    
    If dlgCommon.FileName <> "" Then
        Select Case LCase$(Right$(dlgCommon.FileName, 4))
        Case ".z80"
            SaveZ80Snap dlgCommon.FileName
        Case ".rom"
            SaveROM dlgCommon.FileName
        Case ".sna"
            SaveSNASnap dlgCommon.FileName
        Case ".bmp"
            SaveScreenBMP dlgCommon.FileName
        Case ".scr"
            SaveScreenSCR dlgCommon.FileName
        Case Else
            ' save it as a Z80 file
            SaveZ80Snap dlgCommon.FileName
        End Select
    End If

End Sub



Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If (Shift And 4) Then Exit Sub
    doKey True, KeyCode, Shift
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    doKey False, KeyCode, Shift
End Sub


Private Sub Form_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Data.GetFormat(vbCFFiles) Then
        If (LCase$(Right$(Data.Files(1), 4)) = ".sna") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".z80") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".tap") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".rom") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".scr") Then
            If (Effect And vbDropEffectCopy) Then
                Select Case LCase$(Right$(Data.Files(1), 4))
                Case ".z80"
                    DoEvents
                    If Dir$(Data.Files(1)) <> "" Then LoadZ80Snap Data.Files(1)
                Case ".rom"
                    DoEvents
                    Z80Reset
                    If glEmulatedModel <> 0 And glEmulatedModel <> 5 Then
                        SetEmulatedModel 0
                    End If
                    If Dir$(Data.Files(1)) <> "" Then LoadROM Data.Files(1)
                Case ".sna"
                    DoEvents
                    If Dir$(Data.Files(1)) <> "" Then LoadSNASnap Data.Files(1)
                Case ".tap"
                    DoEvents
                    If Dir$(Data.Files(1)) <> "" Then OpenTAPFile Data.Files(1)
                Case ".scr"
                    DoEvents
                    If Dir$(Data.Files(1)) <> "" Then LoadScreenSCR Data.Files(1)
                End Select
            End If
        End If
    End If
End Sub

Private Sub Form_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    If Data.GetFormat(vbCFFiles) Then
        If (LCase$(Right$(Data.Files(1), 4)) = ".sna") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".z80") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".tap") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".rom") Or _
           (LCase$(Right$(Data.Files(1), 4)) = ".scr") Then
            If (Effect And vbDropEffectCopy) Then
                Effect = vbDropEffectCopy
            Else
                Effect = vbDropEffectNone
            End If
        Else
            Effect = vbDropEffectNone
        End If
    End If
End Sub

Private Sub Form_Resize()
    picStatus.Top = Me.ScaleHeight - picStatus.ScaleHeight
    picStatus.Width = Me.Width
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If gbSoundEnabled Then CloseWaveOut
    
    timeEndPeriod 1
    End
End Sub


Private Sub mnuFile_Click(Index As Integer)
    Dim lWndProc As Long
    
    Select Case Index
    Case 1 ' Open
        If gbSoundEnabled Then waveOutReset glphWaveOut
        FileOpenDialog
        If gbSoundEnabled Then
            waveOutReset glphWaveOut
            For glBufNum = 1 To 12
                waveOutWrite glphWaveOut, gtWavHdr(glBufNum), Len(gtWavHdr(glBufNum))
            Next glBufNum
            glBufNum = 12
        End If
    Case 2 ' Save As
        If gbSoundEnabled Then waveOutReset glphWaveOut
        FileSaveAsDialog
        If gbSoundEnabled Then
            waveOutReset glphWaveOut
            For glBufNum = 1 To 12
                waveOutWrite glphWaveOut, gtWavHdr(glBufNum), Len(gtWavHdr(glBufNum))
            Next glBufNum
            glBufNum = 12
        End If
    Case 4 ' Load Binary
        frmLoadBinary.Show 1
    Case 6 ' Reset
        If gbSoundEnabled Then
            waveOutReset glphWaveOut
            For glBufNum = 1 To 12
                waveOutWrite glphWaveOut, gtWavHdr(glBufNum), Len(gtWavHdr(glBufNum))
            Next glBufNum
            glBufNum = 12
        End If
        Z80Reset
    Case 8 ' Exit
        Unload Me
    End Select
    
    If gbSoundEnabled Then
        waveOutReset glphWaveOut
        For glBufNum = 1 To 12
            waveOutWrite glphWaveOut, gtWavHdr(glBufNum), Len(gtWavHdr(glBufNum))
        Next glBufNum
        glBufNum = 12
    End If
End Sub

Private Sub mnuHelp_Click(Index As Integer)
    Select Case Index
    Case 1 ' // Show spectrum keyboard layout
        frmKeyboard.Show
    Case 3 ' // About... Dialog
        frmAbout.Show 1
    End Select
    
    If gbSoundEnabled Then
        waveOutReset glphWaveOut
        For glBufNum = 1 To 12
            waveOutWrite glphWaveOut, gtWavHdr(glBufNum), Len(gtWavHdr(glBufNum))
        Next glBufNum
        glBufNum = 12
    End If
End Sub

Private Sub mnuOptions_Click(Index As Integer)
    Select Case Index
    Case 1
        frmOptions.Show 1
    Case 2
        frmDisplayOpt.Show 1
    Case 4
        If mnuOptions(Index).Checked Then
            frmTapePlayer.Hide
            mnuOptions(Index).Checked = False
        Else
            frmTapePlayer.Show
            mnuOptions(Index).Checked = True
        End If
        SaveSetting "Grok", "vbSpec", "TapeControlsVisible", IIf(mnuOptions(Index).Checked, "-1", "0")
    End Select
    
    If gbSoundEnabled Then
        waveOutReset glphWaveOut
        For glBufNum = 1 To 12
            waveOutWrite glphWaveOut, gtWavHdr(glBufNum), Len(gtWavHdr(glBufNum))
        Next glBufNum
        glBufNum = 12
    End If
End Sub







Private Sub picDisplay_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Form_OLEDragDrop Data, Effect, Button, Shift, X, Y
End Sub

Private Sub picDisplay_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    Form_OLEDragOver Data, Effect, Button, Shift, X, Y, State
End Sub


Private Sub picStatus_Resize()
    Line1(2).X2 = picStatus.Width
    Line1(3).X2 = picStatus.Width
End Sub


