VERSION 5.00
Begin VB.Form frmTapePlayer 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "vbSpec TZX Tape Controls"
   ClientHeight    =   3105
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   3810
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3105
   ScaleWidth      =   3810
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstBlocks 
      Height          =   2595
      Left            =   0
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   480
      Width           =   3795
   End
   Begin VB.CommandButton cmdNext 
      Height          =   375
      Left            =   3060
      Picture         =   "frmTapePlayer.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   4
      ToolTipText     =   "Next Block"
      Top             =   60
      Width           =   735
   End
   Begin VB.CommandButton cmdPrev 
      Height          =   375
      Left            =   2280
      Picture         =   "frmTapePlayer.frx":0122
      Style           =   1  'Graphical
      TabIndex        =   3
      ToolTipText     =   "Previous Block"
      Top             =   60
      Width           =   735
   End
   Begin VB.CommandButton cmdRewind 
      Height          =   375
      Left            =   1440
      Picture         =   "frmTapePlayer.frx":0244
      Style           =   1  'Graphical
      TabIndex        =   2
      ToolTipText     =   "Rewind to start"
      Top             =   60
      Width           =   795
   End
   Begin VB.CommandButton cmdStop 
      Height          =   375
      Left            =   720
      Picture         =   "frmTapePlayer.frx":0366
      Style           =   1  'Graphical
      TabIndex        =   1
      ToolTipText     =   "Stop/Pause"
      Top             =   60
      Width           =   675
   End
   Begin VB.CommandButton cmdPlay 
      Height          =   375
      Left            =   0
      Picture         =   "frmTapePlayer.frx":0488
      Style           =   1  'Graphical
      TabIndex        =   0
      ToolTipText     =   "Play"
      Top             =   60
      Width           =   675
   End
End
Attribute VB_Name = "frmTapePlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Sub UpdateCurBlock()
    If lstBlocks.ListCount > TZXCurBlock Then lstBlocks.ListIndex = TZXCurBlock
End Sub

Public Sub UpdateTapeList()
    Dim l As Long
    Dim lType As Long, lLen As Long, sText As String
    
    lstBlocks.Clear
    
    For l = 0 To TZXNumBlocks - 1
        GetTZXBlockInfo l, lType, sText, lLen
        lstBlocks.AddItem Hex$(lType) & " - " & sText
    Next l
    
    If lstBlocks.ListCount > TZXCurBlock Then lstBlocks.ListIndex = TZXCurBlock
End Sub

Private Sub cmdNext_Click()
    If (gbTZXInserted) And (TZXCurBlock < TZXNumBlocks - 1) Then
        SetCurTZXBlock TZXCurBlock + 1
    End If
    frmMainWnd.SetFocus
End Sub

Private Sub cmdPlay_Click()
    If gbTZXInserted Then StartTape
    frmMainWnd.SetFocus
End Sub

Private Sub cmdPrev_Click()
    If (gbTZXInserted) And (TZXCurBlock > 0) Then
        SetCurTZXBlock TZXCurBlock - 1
    End If
    frmMainWnd.SetFocus
End Sub

Private Sub cmdRewind_Click()
    If gbTZXInserted Then SetCurTZXBlock 0
    frmMainWnd.SetFocus
End Sub


Private Sub cmdStop_Click()
    If gbTZXInserted Then StopTape
    frmMainWnd.SetFocus
End Sub


Private Sub Form_Activate()
    UpdateCurBlock
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If (Shift And 4) Then Exit Sub
    doKey True, KeyCode, Shift
End Sub


Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    doKey False, KeyCode, Shift
End Sub

Private Sub Form_Load()
    SetWindowPos Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
End Sub


Private Sub Form_Unload(Cancel As Integer)
    frmMainWnd.mnuOptions(4).Checked = False
End Sub


Private Sub lstBlocks_Click()
    UpdateCurBlock
End Sub


